<?php
/**
 * @copyright (c) Kufer Software GmbH, Oderstraße 7, D-84453 Mühldorf
 */

namespace Kufer\Web\KuferTools\Hausmeister\Raumbelegung\RaumUebersicht;

use Kufer\Web\KuferTools\Utils\FilterSearch\KursorteUebersichtSearchFilter;

class RaumUebersichtController extends \Kufer\Web\KuferTools\Basis\Controller\ToolController
{
  protected function getUseCase(): \Kufer\Web\KuferTools\Basis\UseCase\UseCase
  {
    return new RaumUebersichtUseCase(
      $this->getRequestObj()
    );
  }

  protected function getRequestObj()
  {
    $requestObj = new RaumUebersichtRequest();
    $requestObj->seite = \GetOperations::getVarValue('seite');
    $requestObj->einstieg = \GetOperations::isDefined('einstieg');
    $requestObj->aendereFilter = false;

    $tool = 5;
    if ($requestObj->einstieg && !\DBWorkBASysSettings::isIHK()) {
      $suchApi = new KursorteUebersichtSearchFilter();
      $requestObj->suchParameter = $suchApi->getSearchMapFromRequest();
    }
    $requestObj->markieren = \Kufer\Web\KuferTools\Basis\Markieren\Markieren::getMarkierenFromRequest($tool, 'totalraumidstr_');

    return $requestObj;
  }

  protected function getPresenter($pUseCaseResponse)
  {
    return new RaumUebersichtPresenter($pUseCaseResponse);
  }
}